MT = dlmread([datapath '/time.csv']);
MQ = dlmread([datapath '/q.csv']);
MQd = dlmread([datapath '/q_dot.csv']);
MJ = dlmread([datapath '/J.csv']);
MM = dlmread([datapath '/M.csv']);
MX = dlmread([datapath '/X.csv']);
MXd = dlmread([datapath '/Xd.csv']);
MTAU = dlmread([datapath '/tau_mes.csv']);

MN = length(MQ)/7;
MQ2 = reshape(MQ',[7,MN]);
MQd2 = reshape(MQd',[7,MN]);
MQ = MQ2';
MQd = MQd2';
start = 1;
if exist('fraction','var')
  stop  = floor(fraction * length(MT)); % chop off last part if needed
else
  stop  = length(MT);
end

% T  = MT(start:stop,1);     % time (time data is not reliable...)
T  = 0.001*[0:stop-1].';     % time (1 KHz sampling)

Q  = MQ(start:stop,1:7);    % Joint position
Qd  = MQd(start:stop,1:7);    % Joint velocity 

X  = MX(start:stop,1:7);      % end effector pose (frame_7)
Xd = MXd(start:stop,1:6);
TAU = MTAU(start:stop,1:7);

J  = [ MJ(0+[start:6:6*stop],1:7) , ...
       MJ(1+[start:6:6*stop],1:7) , ... 
       MJ(2+[start:6:6*stop],1:7) , ... 
       MJ(3+[start:6:6*stop],1:7) , ... 
       MJ(4+[start:6:6*stop],1:7) , ... 
       MJ(5+[start:6:6*stop],1:7) ];
     
M  = [ MM(0+[start:7:7*stop],1:7) , ...
       MM(1+[start:7:7*stop],1:7) , ... 
       MM(2+[start:7:7*stop],1:7) , ... 
       MM(3+[start:7:7*stop],1:7) , ... 
       MM(4+[start:7:7*stop],1:7) , ... 
       MM(5+[start:7:7*stop],1:7) , ... 
       MM(6+[start:7:7*stop],1:7) ];