clear all
close all
clc

set(0,'defaultTextInterpreter','latex')
set(0,'defaultAxesTickLabelInterpreter','latex')

tstart  = 0;
tfinal  = 0.5; % 1.5;

walllvl = 0;

dt       = 1e-8;
exf2     = -100;
x0       = [walllvl;0.4;0.4;0;0;0];
opts     = odeset('RelTol',1e-12,'AbsTol',1e-12);
[t,x,Fn] = ode15s(@(t,x) Flex_Complaint(t,x,exf2),[tstart tfinal],x0,opts);


FS.t = t;
FS.x1 = x(:,2);
FS.x2 = x(:,3);
FS.x1d = x(:,5);
FS.x2d = x(:,6);

save('FS_results','FS')

figure(1)
subplot(3,2,1)
plot(t,x(:,1))
subplot(3,2,2)
plot(t,x(:,4))
subplot(3,2,3)
plot(t,x(:,2))
subplot(3,2,4)
plot(t,x(:,5))
subplot(3,2,5)
plot(t,x(:,3))
subplot(3,2,6)
plot(t,x(:,6))
% plot(t,-(x(:,2)-x(:,1)))

Krob = 1e4;
Drob = 8e1;
for i = 1:length(t)
    y = x(i,2);
    ywall = x(i,1);
    ydot = x(i,4)-x(i,5);
    fnn(i) = HCFn_NRL(y,ydot,ywall);
    Fkd(i) = Krob*(x(i,3)-x(i,2))+Drob*(x(i,6)-x(i,5));
end

figure(3)
subplot(3,1,1)
plot(t,x(:,1 )-x(:,2),'LineWidth',1)
xlabel('time [s]','FontSize',12)
ylabel('$\delta(t)$ [m]','FontSize',12)
grid on
grid minor
subplot(3,1,2)
plot(-(x(:,2)-x(:,1)),fnn,'LineWidth',1)
xlabel('$\delta(t)$ [m]','FontSize',12)
ylabel('$F_c(\delta(t),\dot{\delta}(t))$ [N]','FontSize',12)
grid on
grid minor
subplot(3,1,3)
plot(-(x(:,2)-x(:,1)),fnn,'LineWidth',1)
xlabel('$\delta(t)$ [m]','FontSize',12)
ylabel('$F_c(\delta(t),\dot{\delta}(t))$ [N]','FontSize',12)
grid on
grid minor

figure(4)
subplot(2,1,1)
plot(t,fnn,'LineWidth',1)
hold on
plot(t,Fkd,'LineWidth',1)
xlabel('time [s]','FontSize',12)
ylabel('Force [N]','FontSize',12)
grid on
grid minor
subplot(2,1,2)
plot(t,fnn,'LineWidth',1.2)
hold on
plot(t,Fkd,'LineWidth',1.2)
xlabel('time [s]','FontSize',12)
ylabel('Force [N]','FontSize',12)
grid on
grid minor
legend('F_c','F_{k_{rob}}+F_{d_{rob}}')

