clear all
% close all
clc


y0 = [0; 20];
refine = 1;

options = odeset('Events',@events_fcn,'OutputFcn',@odeplot,'OutputSel',1,...
   'Refine',refine);

x0      = [0.4;0.4;0;0];
exf2    = -100;

tstart  = 0;
tfinal  = 0.5; % 1.5

walllvl = 0;

tout = tstart;
xout = x0.';
teout = [];
xeout = [];
ieout = [];

m0 = 5;
m1 = 1;
% for i = 1:2
    
%     if i == 1
        [t,x,] = ode23s(@(t,x) Flex_HardA(t,x,exf2),[tstart tfinal],x0,options);
        nt = length(t);
        x0(1) = x(nt,1);
        x0(2) = x(nt,2);
        x0(3) = m1*x(nt,3)/(m0+m1);
        x0(4) = x(nt,4);
%    nt = length(t);
        options = odeset('InitialStep',t(nt)-t(nt-refine),...
      'MaxStep',t(nt)-t(1));
  
        tstart = t(nt);
        tout = [tout; t];
        xout = [xout; x];
        [t,x,]   = ode23s(@(t,x) Flex_HardP(t,x,exf2),[tstart tfinal],x0,options);
        nt = length(t);
%         x0(1) = x(nt,1);
%         x0(2) = x(nt,2);
%         x0(3) = x(nt,3);
%         x0(4) = x(nt,4);
%     end
%     
%     if ~ishold
%       hold on
%     end
    % Accumulate output.
    nt = length(t);
    tout = [tout; t(1:nt)];
    xout = [xout; x(1:nt,:)];
  
    
  
    
   
% end

FH.t = tout;
FH.x1 = xout(:,1);
FH.x2 = xout(:,2);
FH.x1d = xout(:,3);
FH.x2d = xout(:,4);

save('FH_results','FH')

figure(2)
subplot(2,2,1)
plot(tout,xout(:,1))
xlabel('time [s]')
ylabel('pos [m]')
grid on
grid minor
subplot(2,2,2)
plot(tout,xout(:,2))
xlabel('time [s]')
ylabel('pos [m/s]')
grid on
grid minor
subplot(2,2,3)
plot(tout,xout(:,3))
xlabel('time [s]')
ylabel('vel [m]')
grid on
grid minor
subplot(2,2,4)
plot(tout,xout(:,4))
xlabel('time [s]')
ylabel('vel [m/s]')
grid on
grid minor

% figure(3)
% plot(t,x(:,4))